#ifndef INDEXWINDOW_H
#define INDEXWINDOW_H

#include <qptrlist.h>
#include <qstring.h>

#include ".ui/indexwindowbase.h"

class QIconViewItem;
class QPoint;

class Book;
class PictureItem;


class IndexWindow : public IndexWindowBase
{
    public:
        IndexWindow(QString index);

        void action_newIndex_activated();
        void action_openIndex_activated();
        void action_saveIndex_activated();
        void action_saveIndexAs_activated();
        void action_rebuildPictures_activated();
        void action_refreshPictures_activated();
        void action_generateHTML_activated();
        void action_previewHTML_activated();
        void action_importPictures_activated();
        void text_title_textChanged(const QString& title);
        void text_date_textChanged(const QString& date);
        void view_pictures_itemRenamed(QIconViewItem* it,
                                       const QString& newDesc);
        void view_pictures_selectionChanged();
        void view_pictures_clicked(QIconViewItem* it);
        void view_pictures_rightButtonClicked(QIconViewItem* it,
                                              const QPoint& p);
        void action_closeIndex_activated();
        void action_selectNone_activated();
        void action_selectAll_activated();
        void action_invertSelection_activated();
        void action_deletePictures_activated();
        void action_about_activated();
        void action_aboutQt_activated();
        void action_changeSettings_activated();
        void action_moveBackward_activated();
        void action_moveForward_activated();
    
    protected:
        QPtrList<PictureItem>* getSelectedPictures();
        void enableAll();
        void disableAll();
        void updatePictures();

        Book* book() const { Q_CHECK_PTR(book_); return book_; }

    private:
        Book* book_;
};

#endif
