#include <qapplication.h>
#include <qfileinfo.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <iostream>

#ifdef HAVE_CONFIG
#include "config.h"
#else
#include "defaults.h"
#endif

#include "htmlgenerator.h"
#include "indexwindow.h"
#include "imagemanager.h"
#include "book.h"

using namespace std;

void help() {
    /* TODO */
    cerr << "Usage: spit [OPTION] [FILE]" << endl 
         << endl 
         << "   -u     Updates the index specified in FILE" << endl
         << endl;
}

/* Main */
int main(int argc, char** argv) {
    QString indexFile;
    bool update = false, create = false;

    /* Initialize application */
    QApplication a( argc, argv );

    /* Do i18n stuff */
    QTranslator trans( 0 );
    trans.load( QString( "spit_" ) + QTextCodec::locale(), LIBDIR "i18n/" );
    a.installTranslator( &trans );

    /* Parse arguments */
    for (int i=1; i < argc; i++) {
        QString arg(argv[i]);
        if (arg == "-h" || arg == "--help") {
            help();
            return 0;
        }
        else if (arg == "-c" || arg == "--create") {
            create = true;
        }
        else if (arg == "-u" || arg == "--update") {
            update = true;
        }
        else if (indexFile.isEmpty()) {
            indexFile = arg;
        }
        else 
            qWarning("Invalid command-line argument");
    }
    
    
    if (create || update) {
//        if (indexFile.isEmpty()) 
//            qFatal("Error: Create or update requires index file.");
//        if (create) {
//            /* TODO */
//        }
//        if (update) {
//            if (QFileInfo(indexFile).exists()) {
//                Book* info = new Book(indexFile);
//                manager->update();
//                createIndexHTML(info);
//                if (info->getBoolAttribute("slides_create"))
//                    createSlidesHTML(info);
//            }
//            else 
//                qFatal("Error: " + indexFile + " does not exist.");
//        }
//        return 0;
    }
    else {
        /* Initialize main window */
        IndexWindow d(indexFile);
        a.setMainWidget(&d);
        d.show();

        /* Start application */
        return a.exec();
    }
}
