#ifndef PICTURECONTEXTMENU_H
#define PICTURECONTEXTMENU_H

#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qstring.h>

class PictureItem;

class PictureContextMenu : public QPopupMenu
{
    Q_OBJECT

    public:
        PictureContextMenu(QWidget* parent, PictureItem* pictureitem);
        ~PictureContextMenu();

    public slots:
        void edit();
        void info();
        void refresh();
        void rebuild();
        void remove();
        void rename();
        void rotate90();
        void rotate180();
        void rotate270();

    protected:
        PictureItem* picture() { Q_CHECK_PTR(picture_); return picture_; }

    private:
        QPixmap loadPixmap(const QString &name);
        PictureItem* picture_;
        QPopupMenu* rotateMenu_;
};

#endif
