#ifndef PICTUREITEM_H
#define PICTUREITEM_H

#include <qiconview.h>
#include <qstring.h>

class Picture;

class PictureItem : public QIconViewItem
{
    public:
        PictureItem(QIconView*  parent, Picture* picture); 
        
        Picture* getPicture() const 
            { Q_CHECK_PTR(picture_); return picture_; }
        int compare(QIconViewItem* i) const;

        void setDescription(const QString& text);
        void moveBackward();
        void moveForward();
        void edit();
        void refresh();
        void rebuild();
        void remove(bool removeFile = false);
        void rename(QString& name);
        void rotate(double degrees);

    private:
        int index_;
        Picture* picture_;
};

#endif
